Animation = Object:extend()


function Animation:new(path, fps, xOffset, yOffset, frameOffset)
  self.fps = fps
  self.frames = {}
  self.shadowFrames = {}
  self.xOffset = xOffset or 0
  self.yOffset = yOffset or 0

  self.frameOffset = frameOffset or 0

  
  --[[From https://www.reddit.com/r/lua/comments/xpqabs/how_to_list_all_files_in_a_directory/
  local cmd = 'dir "%s" /b'
  if (jit and jit.os == "Linux") then
    cmd = 'ls -1 "%s"'
  end

  
  
  for filename in io.popen(string.format(cmd, path)):lines() do
    
  end
end
--Thank you Grom for linux compatability!]]

  if not file_exists("textures/"..path) then
    error(path.." does not exist!")
  end


  for i, filename in ipairs(love.filesystem.getDirectoryItems("textures/"..path)) do
    if string.sub(filename, #filename-9, #filename) ~= "Shadow.png" then
      table.insert(self.frames, textureSet(path.."/"..string.sub(filename, 1, #filename-4)))
    end
  end
end



function Animation:play(x, y, r, sx, sy)
  if self.timeStarted == nil then
    self.timeStarted = love.timer.getTime()
  end
  
  self.currentFrame = math.floor(((love.timer.getTime() - self.timeStarted)*self.fps+self.frameOffset)%#self.frames)+1
  
  blue.graphics.drawCentredSet(self.frames[self.currentFrame], x, y, r, sx, sy, self.xOffset, self.yOffset)
  
  if self.shadowFrames[1] then
    love.graphics.setColor(0,0,0, scene.lightHarshness)
    blue.graphics.drawCentred(self.shadowFrames[self.currentFrame], x, y, r, sx, sy, self.xOffset, self.yOffset)
  end
  
  if (love.timer.getTime() - self.timeStarted) > 1/self.fps * #self.frames then
    return true
  else
    return false
  end
end



function Animation:stop()
  self.timeStarted = nil
end

