CloudSheet = Entity:extend()


function CloudSheet:new(x, y, z)
  CloudSheet.super.new(self, x, y)
  self.z = z
  self.type = "cloudSheet"
  
  if z == 0 then
    print("WARNING - Z WAS 0. SETTING TO 1")
    self.z = 1
  end
end

function CloudSheet:update(dt)
  self.x = self.x + 1000*dt
end


function CloudSheet:draw()
  local scale = 10 * self.z
  
  local fallOffConstant = 4
  
  love.graphics.setColor(1, 1, 1, 0.4*fallOffConstant/(self.z + fallOffConstant - 1))
  local texture = texture[self.type]
  local textureWidth = texture:getWidth()
  local textureHeight = texture:getHeight()
  
  
  local primaryX = math.floor((-camera.x+(textureWidth/2*scale))/(textureWidth*scale)) * textureWidth*scale 
  local primaryY = math.floor((-camera.y+(textureHeight/2*scale))/(textureHeight*scale)) * textureHeight*scale
  
  --[[if self.z == 1.01 then
    love.graphics.setColor(1,0,1)
    blue.graphics.circle("line", primaryX, primaryY, 10)
  end]]
  
  local noXPanels = ((window.width/ camera.zoom)/(textureWidth*scale/self.z))
  local noYPanels = ((window.height/camera.zoom)/(textureHeight*scale/self.z))

  --i = 0
 --j = 0
  
  --noXPanels = 0
  --noYPanels = 0
  
  --if self.z%2 then
   -- flip
  
  for i = math.floor(-noXPanels/2-1), math.ceil(noXPanels/2) do 
    for j = math.floor(-noYPanels/2-1), math.ceil(noYPanels/2) do
      
      blue.graphics.parallaxDraw(
        texture,
        primaryX + (textureWidth*scale)*i, 
        primaryY + (textureHeight*scale)*j,
        self.z,
        0,
        scale, 
        scale
      )
      
      --[[love.graphics.setColor(0,0,0,0.5)
      blue.graphics.parallaxCircle(
        "line",
        primaryX + (textureWidth*scale)*i + (scale*textureWidth*0.5), 
        primaryY + (textureHeight*scale)*j + (scale*textureWidth*0.5),
        self.z,
        (scale*textureWidth*0.5)/self.z
        
      )]]
      
    end
  end
  
  
  
  --end
  --blue.graphics.parallaxDraw(texture, self.x + texture:getWidth(), self.y, self.z, 0, 1, 1, texture:getWidth()/2, texture:getHeight()/2)
end