console = {}
console.x = 10
console.y = 10
console.lines = {}



function cout(...)
  args = {...}
  local final = ""
  for i, argument in ipairs(args) do
    if i == 1 then
      final = tostring(argument)
    else
      final = final.."\t"..tostring(argument)
    end
  end
  
  local newLine = {}
  newLine.value = final
  newLine.time = love.timer.getTime()
  
  table.insert(console.lines, newLine)
end



function console:draw()
  local textScale = 1.5
  local displayedLines = 0
  local maxLines
  for i, line in ipairs(console.lines) do
    if love.timer.getTime() - line.time < 5 then
      love.graphics.setColor(0,0,0,0.5)
      love.graphics.print(line.value, self.x, self.y+font:getHeight()*textScale*displayedLines, 0, textScale, textScale)
      love.graphics.setColor(1,0.9,0.2)
      love.graphics.print(line.value, self.x-2, self.y+font:getHeight()*textScale*displayedLines-2, 0, textScale, textScale)
      displayedLines = displayedLines + 1
    end
  end
end


function console:dumpOutput()
  for i, line in ipairs(console.lines) do
    print(line.value)
  end
end