Interactable = Prop:extend()

require "entities/interactables/special interactables"
require "entities/interactables/button"
require "entities/interactables/talkative"
require "entities/interactables/door"


function Interactable:new(x, y, texture, attributes)
  Interactable.super.new(self, x, y, texture, attributes)
  self.type = "interactable"
  self.isInteractable = true
  createAttribute(self.attributes, "name", "")
  createAttribute(self.attributes, "priority", false)
  createAttribute(self.attributes, "interactRadius", 100)
  createAttribute(self.attributes, "requiresFacing", false)
  createAttribute(self.attributes, "singleUse", false)
  
  self.active = true
  
  
end


function Interactable:interact(playerPosition)
  -- Player position is relative to the interactable
  
  if self.attributes.singleUse and not self.active then -- this section should never activate
    cout("Error with interact!")
  end
  
  
  
  if self.attributes.singleUse then
    if self.active then
      if self.attributes.name ~= "unnamed" then
        
        if specialInteract[self.attributes.name] then
          specialInteract[self.attributes.name](self, playerPosition)
        else
          cout("No special interact called '"..self.attributes.name.."'")
        end
      end
      self:activate()
      self.active = false
      
    end
  else
    if self.attributes.name ~= "unnamed" then
        if specialInteract[self.attributes.name] then
          specialInteract[self.attributes.name](self, playerPosition)
        end
      end
    self:activate(playerPosition)
  end
end


function Interactable:update()
  if specialUpdate[self.attributes.name] then
    specialUpdate[self.attributes.name](self)
  end
end


function Interactable:activate(playerPosition)
  print("WARNING: Interactable has no behaviour!")
end