Talkative = Button:extend()

specialDialogue = {}

function Talkative:new(x, y, texture, attributes)
  Talkative.super.new(self, x, y, texture, attributes)
  self.type = "talkative"
  self.currentBook = 1
  createAttribute(self.attributes, "book1", "boop")
end



function Talkative:activate(book)
  if not dialogueBox.displayed then
    self:playDialogue()
  end
end



function Talkative:playDialogue()
  if specialDialogue[self.attributes.name] then
    specialDialogue[self.attributes.name](self)
  else
    
    self:showBook(self.currentBook)
  end
  
end

function Talkative:showBook(number)
  dialogueBox:loadBook(self.attributes["book"..number])
end



function specialDialogue.linearRepeat(self)
  dialogueBox:loadBook(self.attributes["book"..self.currentBook])
  self.currentBook = self.currentBook + 1
  if self.attributes["book"..self.currentBook] == "" or self.attributes["book"..self.currentBook] == nil then
    self.currentBook = 1
  end
end
  
  
function specialDialogue.linearRepeatEnd(self)
  dialogueBox:loadBook(self.attributes["book"..self.currentBook])
  if not (self.attributes["book"..self.currentBook+1] == "" or self.attributes["book"..self.currentBook+1] == nil) then
    self.currentBook = self.currentBook + 1
  end
end


function specialDialogue.queueAllBooks(self)
  local books = {}
  for name, value in pairs(self.attributes) do
    if string.sub(name, 1, 4) == "book" and value ~= "" then
      books[tonumber(string.sub(name, 5, 5))] = value
    end
  end
  
  for i, value in ipairs(books) do
    dialogueBox:queueBook(value)
  end
end
  

  


function specialDialogue.voltehre(self)
  
  local prefix = "volt/first meeting/"
  if not event.talkedToVolt then
    event.talkedToVolt = true
    
    dialogueBox:queueBook(prefix.."1")
    
    if event.voltMural[0] then
      event.volt.knowledge.murals = true
      dialogueBox:queueBook(prefix.."2 mural")
    else
      dialogueBox:queueBook(prefix.."2 no mural")
    end
    if event.talkedToCordelia then
      dialogueBox:queueBook(prefix.."3 cordelia")
    else
      dialogueBox:queueBook(prefix.."3 no cordelia")
    end
  else
    dialogueBox:queueBook(prefix.."secondary")
  end
end


function specialDialogue.cordelia(self)
  
  local prefix = "cordelia/"
  if event.talkedToVolt then
    if event.talkedToCordelia then
      if event.taughtMagic then
        dialogueBox:queueBook(prefix.."met volt secondary")
      else
        dialogueBox:queueBook(prefix.."2 not met volt")
        event.taughtMagic = true
      end
    else
      dialogueBox:queueBook(prefix.."met volt")
      event.taughtMagic = true
    end
    
  else
    if not event.talkedToCordelia then
      dialogueBox:queueBook(prefix.."1 not met volt")
    else
      dialogueBox:queueBook(prefix.."1 not met volt secondary")
    end
  end
  
  
  
  
  event.talkedToCordelia = true
end
    
    
    