function beginContact(a, b, coll)
  if a:getUserData() == "sensor" or b:getUserData() == "sensor" then
    groundSensor.triggered = true
  end
end

function endContact(a, b, coll)
  player1.collisionTable[a] = nil
  player1.collisionTable[b] = nil
end


function postSolve(a, b, coll, normalimpulse, tangentimpulse)
 
	if a:getUserData() == "player" or b:getUserData() == "player" then
    player1.collisionImpulse = normalimpulse
    
    if normalimpulse > 80 then
      sound.effect.thud:setVolume((normalimpulse-60)/200)
      sound.effect.thud:play()
    end
    if a:getUserData() == "player" then
      if player1.collisionTable[b] and player1.collisionTable[b].frame == currentFrame then
        
        
      else
        player1.collisionTable[b] = {}
        player1.collisionTable[b].x, player1.collisionTable[b].y  = coll:getNormal( )
        player1.collisionTable[b].frame = currentFrame
      end
      
    else  
      player1.collisionTable[a] = {}
      player1.collisionTable[a].x, player1.collisionTable[a].y  = coll:getNormal( )
      player1.collisionTable[a].frame = currentFrame
    end
  elseif (a:getUserData() and a:getUserData().type == "sword") or (b:getUserData() and b:getUserData().type == "sword") then
    local sword = nil
    if (a:getUserData() and a:getUserData().type == "sword") then
      sword = a:getUserData()
      if not sword.locked then
        sword.lockedBody = b:getBody()
      end
    end
    if (b:getUserData() and b:getUserData().type == "sword") then
      sword = b:getUserData()
      if not sword.locked then
        sword.lockedBody = a:getBody()
      end
    end

    sword.locked = true
    
    
  end
end


function Player:getCollisionVectors()
  
  local numberOfEntries = 0
  for i, v in pairs(player1.collisionTable) do
    numberOfEntries = numberOfEntries + 1
  end
  if numberOfEntries > 0 then
    self.contactWithGround = true
  else
    self.contactWithGround = false
    return
  end
  local trueAverageNormal = vector.create(0,0)
  local averageNormal = vector.create(0,0)
  local averageVelocity = vector.create(0, 0)
  for i, v in pairs(self.collisionTable) do
    trueAverageNormal = vector.addition(averageNormal, v)
    --Check to see if the surfaces are valid for walking on
    if self:canWalkPart(v) then
      averageNormal = vector.addition(averageNormal, v)
      averageVelocity = vector.addition(averageVelocity, vector.scalarMultiplication(vector.create(i:getBody():getLinearVelocity()), 1/numberOfEntries))
    end
  end
  trueAverageNormal = vector.normalize(trueAverageNormal)
  averageNormal = vector.normalize(averageNormal)
  
  self.tangentWithGround = vector.turn90Degrees(vector.normalize(averageNormal))
  local relativeVelocity = vector.subtraction(self.velocityLastFrame, averageNormal)
  self.tangentVelocity = vector.project(relativeVelocity, player1.tangentWithGround)
  self.walkableNormalVelocity = vector.project(relativeVelocity, averageNormal)
  self.normalVelocity = vector.project(relativeVelocity, trueAverageNormal)
  self.normalWithGround = averageNormal
  
end



